global function placeGlitchObjects

struct
{
    bool isthere = false
} file

const int moveTime = 5

void function placeGlitchObjects()
{
    // PrecacheModel( $"models/training/sp_training_wood_gunrack_01.mdl" )

    CreateSimpleButton( < -167, 97, -55 >, <0, 75, 0>, " to control the bridge barriers", callback_ButtonTriggered )

    CreateSmallElevator( < -1336, 125, -888 >, < -1263, 125, 1025 >, 6 )
    CreateSmallElevator( < 1002, 125, -888 >, < 1002, 125, 1025 >, 6 )
    
    for( int x = 0; x < 350; x += 50 )
    {
        entity mover = CreateExpensiveScriptMoverModel( $"models/props/turret_base/turret_base.mdl", < -30 - x, -10, 35 >, <90,0,0>, SOLID_VPHYSICS, 10000 )
        mover.SetPusher( true )
        mover.SetScriptName( "glitch_blocker1" )
    }

    for( int x = 0; x < 350; x += 50 )
    {
        entity mover = CreateExpensiveScriptMoverModel( $"models/props/turret_base/turret_base.mdl", < -30 - x, 260, 35 >, <90,0,0>, SOLID_VPHYSICS, 10000 )
        mover.SetPusher( true )
        mover.SetScriptName( "glitch_blocker1" )
    }

    thread LowerBlocker()

    CreateNessy( <1387.47, -507.165, 147.031>, <0, -60, 0> )

}

void function callback_ButtonTriggered( entity button, entity player )
{
    if ( file.isthere )
    {
        thread LowerBlocker()
    }
    else
    {
        thread RaiseBlocker()
    }

    file.isthere = !file.isthere
}

void function RaiseBlocker()
{
    foreach( entity mover in GetEntArrayByScriptName( "glitch_blocker1" ) )
    {
        mover.NonPhysicsMoveTo( mover.GetOrigin() + <0,0,2200>, moveTime, 0.1, 0.1 )
    }

    wait moveTime + 1

    foreach( entity mover in GetEntArrayByScriptName( "glitch_blocker1" ) )
    {
        mover.NonPhysicsRotateTo( <90,90,0>, 0.5, 0.1, 0.1 )
    }
}

void function LowerBlocker()
{
    foreach( entity mover in GetEntArrayByScriptName( "glitch_blocker1" ) )
    {
        mover.NonPhysicsRotateTo( <90,0,0>, 0.5, 0.1, 0.1 )
    }

    wait 0.8

    foreach( entity mover in GetEntArrayByScriptName( "glitch_blocker1" ) )
    {
        mover.NonPhysicsMoveTo( mover.GetOrigin() - <0,0,2200>, moveTime, 0.1, 0.1 )
    }
}